﻿/**
* ...
* @author George
* Koch curve, discovered by the Swedish mathematician Helge von Koch in 1904.
* 
* Experiment class, source from Computer Graphics for Java Programmers by by Leen Ammeraal and Kang Zhang
* 
* @version 0.1
*/

package com.neatfilm.graphics.fractal {
	import flash.display.Sprite;

	public class Koch extends Sprite
	{
		private var dir:Number;
		private var _midX:int;
		private var _midY:int;
		private var _level:int;
			
		private var _w:Number;
		private var _h:Number;
		
		private var _color:Number;
		
		private var tx:Number;
		private var ty:Number;
		
		public function Koch(w:Number, h:Number, level:int, color:Number) {
			_w = w;
			_h = h;
			_level = level;
			if(_level<1){
				_level = 1;
			}
			_color = color;
			
			draw();
		}
		public function draw():void
		{
			var maxX:Number = _w - 1;
			var maxY:Number = _h - 1;
			var length:Number = 3 * maxX / 4;
			_midX = maxX / 2;
			_midY = maxY / 2;
			
			//start point
			tx = - length / 2;
			ty = 0;
			dir = 0;
			
			graphics.lineStyle(1, _color);
			drawKoch(length, _level);
		}
		public function drawKoch(len:Number, n:int):void
		{
			// turtle graphics method
			// if n=0, draw a straight line
			if(n==0){
				var dirRad:Number;
				var xInc:Number;
				var yInc:Number;
				dirRad = dir * Math.PI / 180;
				xInc = len * Math.cos(dirRad);
				yInc = len * Math.sin(dirRad);
				var x1:Number = tx + xInc;
				var y1:Number = ty + yInc;
				graphics.moveTo(iX(tx), iY(ty));
				graphics.lineTo(iX(x1), iY(y1));
				tx = x1;
				ty = y1;
			} else {
				drawKoch(len/=3, --n);
				dir += 60;
				drawKoch(len, n);
				dir -= 120;
				drawKoch(len, n);
				dir += 60;
				drawKoch(len, n);
			}
		}
		
		private function iX(x:Number):int
		{
			return Math.round(_midX + x);
		}
		private function iY(y:Number):int
		{
			return Math.round(_midY - y);
		}
		
		
	}
	
}
